<?php

include('/usr/local/www/berogui/misc/database.php');
require_once('/usr/fallback/beroConf.php');
require_once('/usr/local/www/berogui/includes/Helper/Helper.php');

class apiCall {

	private $_name, $_parameters, $_files, $_execResult, $_execResultString, $_execResponseCode;

	function __construct ($get = null, $post = null, $files = null) {
		$this->_name = basename(dirname(__FILE__));
		$this->_parameters = array_merge($get, $post);
		$this->_files = $files;
		$this->_execResult = true;
		$this->_execResponseCode = 200;
		$this->_execResultString = 'success';
	}

	function execute () {

		$validSetting = false;

		$bc = new beroConf('root');

		if (isset($this->_parameters['Mode']) && in_array($this->_parameters['Mode'], array('enabled', 'disabled'))) {
			$bc->set('root', 'snmp-enabled', (($this->_parameters['Mode'] == 'enabled') ? 1 : 0));
			$validSetting = true;
		}

		if (isset($this->_parameters['DeviceLocation'])) {
			$bc->set('root', 'snmp-syslocation', sqlite_escape_string($this->_parameters['DeviceLocation']));
			$validSetting = true;
		}

		if (isset($this->_parameters['RoCommunity'])) {
			$bc->set('root', 'snmp-community-ro', sqlite_escape_string($this->_parameters['RoCommunity']));
			$validSetting = true;
		}

		if (isset($this->_parameters['RwCommunity'])) {
			$bc->set('root', 'snmp-community-rw', sqlite_escape_string($this->_parameters['RwCommunity']));
			$validSetting = true;
		}

		if (isset($this->_parameters['TrapCommunity'])) {
			$bc->set('root', 'snmp-community-trap', sqlite_escape_string($this->_parameters['TrapCommunity']));
			$validSetting = true;
		}

		if (isset($this->_parameters['TrapSink'])) {
			$bc->set('root', 'snmptraps_sink', sqlite_escape_string($this->_parameters['TrapSink']));
			$validSetting = true;
		}

		if (isset($this->_parameters['TrapInterval'])) {
			$bc->set('root', 'snmptraps_intervall', sqlite_escape_string($this->_parameters['TrapInterval']));
			$validSetting = true;
		}

		if (isset($this->_parameters['Traps'])) {

			$trapsString = '';

			if ($this->_parameters['Traps'] == 'IsdnLayer2') {
				$trapsString .= ((strlen($trapsString) == 0) ? '' : ',') . 'snmptrap_isdnl2';
			}

			$bc->set('root', 'snmptraps', $trapsString);
			$validSetting = true;
		}

		if ($validSetting == false) {
			$this->_execResultString = 'error:invalid_parameters;';
			$this->_execResult = false;
			$this->_execResponseCode = 405;
			return($this->_execResult);
		}

		Helper::activate(2);

		return($this->_execResult);
	}

	function display () {
		return($this->_name . ':' . $this->_execResultString);
	}

	function responsecode () {
		return($this->_execResponseCode);
	}
}

?>
